package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.BaseBrand;
import com.ruoyi.web.base.service.IBaseBrandService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 品牌 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-03
 */
@RestController
@RequestMapping("/base-brand")
public class BaseBrandController {
    @Autowired
    private IBaseBrandService baseBrandService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("品牌管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody BaseBrand baseBrand, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseBrandService.count(new QueryWrapper<BaseBrand>().eq("org_id",loginOrgId).eq("brand_num", baseBrand.getBrandNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseBrand.setOrgId(loginOrgId);
        baseBrand.setCreateBy(getUsername());

        return success(baseBrandService.save(baseBrand));
    }

    @ApiOperation("品牌管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody BaseBrand baseBrand, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (baseBrandService.count(new QueryWrapper<BaseBrand>().ne("id",baseBrand.getId()).eq("org_id",loginOrgId).eq("brand_num", baseBrand.getBrandNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        baseBrand.setUpdateBy(getUsername());
        return success(baseBrandService.updateById(baseBrand));
    }

    @ApiOperation("品牌管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            baseBrandService.removeById(s);
        }
        return success();
    }

    @ApiOperation("品牌管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(baseBrandService.list(new QueryWrapper<BaseBrand>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("品牌管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(baseBrandService.page(new Page<BaseBrand>(pageNum,pageSize),new QueryWrapper<BaseBrand>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("品牌管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(baseBrandService.getById(id));
    }
}
